import java.io.Serializable;

/**
 * 勇者クラス
 * 
 * @author はがねのつるぎ
 *
 */
public class Hero implements Serializable {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	/** 勇者の名前 */
	private String name = null;
	
	/** ヒットポイント */
	private int hp = 0;
	
	/** マジックポイント*/
	private int mp = 0;
	
	/** 最大ヒットポイント */
	private int max_hp = 0;
	
	/** 最大マジックポイント */
	private int max_mp = 0;
	
	/** 勇者インスタンスを保持(Singleton) */
	private static Hero hero = new Hero();

	/**
	 * コンストラクタ Staticフィールドで初期化するためのデフォルトコンストラクタ
	 */
	private Hero(){
	}
	
	/**
	 * 勇者クラスを初期化する。名前と初期パラメータの設定
	 * @param name 勇者の名前
	 */
	public static Hero init(String name){
	//public boolean init(String name){
	//private Hero(String name) {
		Hero h = Hero.hero;
		if(h.name == null){ //TODO 例外を返すか検討
			return h;
		}
		
		if( null == name || name.equals("") || name.length() > 4 ) //TODO 入力画面でチェック済みなら不要か？
		{
			throw new IllegalArgumentException();
		}
		h.name = name;
		
		h.max_hp = 10;
		h.max_mp = 10;
		h.hp = h.max_hp;
		h.mp = h.max_mp;
		
		return h;
	}

	/**
	 * インスタンスを取得する
	 * @return Hero
	 */
	public static Hero getInstance(){
		//if ( Hero.hero == null ){
		if ( Hero.hero.getName() == null ){
			throw new NullPointerException(); //TODO 例外クラス検討
		}
		return Hero.hero;
	}
	/*
	public static synchronized Hero getInstance(String name){
		if ( Hero.hero == null ){
			Hero.hero = new Hero(name);
		}
		return Hero.hero;
	}
	*/
	
	
	/**
	 * @return the hp
	 */
	public int getHp() {
		return hp;
	}

	/**
	 * HPを0から最大HPの範囲で設定する。
	 * @param hp the hp to set
	 */
	public void setHp(int hp) {
//		if( hp < 0 ){
//			this.hp = 0;
//		} else if ( hp > this.max_hp  ) {
//			this.hp = this.max_hp;
//		} else {
//			this.hp = hp;
//		}
		this.hp = ( hp < 0 ) ? 0 : ( hp > this.max_hp  ) ? this.max_hp: hp;
	}

	/**
	 * @return the mp
	 */
	public int getMp() {
		return mp;
	}

	/**
	 * MPを0から最大MPの範囲で設定する。
	 * @param mp the mp to set
	 */
	public void setMp(int mp) {
		this.mp = ( mp < 0 ) ? 0 : ( mp > this.max_mp  ) ? this.max_mp: mp;
	}

	/**
	 * @return the name
	 */
	public String getName() {
		return name;
	}
	
	
	
	
	
}
